<?php
/**
 * @brief  planner 모듈의 admin controller class
 * @author BNU <bnufactory@gmail.com>
 **/
class plannerAdminController extends planner {

    function init() {
        parent::init();
    }

    function procPlannerAdminInsertConfig() {
        $this->module_config->enable_personalize = Context::get('enable_personalize');
        $this->module_config->personalize_skin = Context::get('personalize_skin');
        if($this->module_config->enable_personalize != 'Y') $this->module_config->enable_personalize = 'N';

        // module Controller 객체 생성하여 입력
        $oModuleController = &getController('module');
        $output = $oModuleController->insertModuleConfig('planner', $this->module_config);
        return $output;
    }


    /**
     * @brief 추가/수정
     **/
    function procPlannerAdminInsertPlanner($args = null) {
        // module 모듈의 model/controller 객체 생성
        $oModuleController = &getController('module');
        $oModuleModel = &getModel('module');

        // 일단 입력된 값들을 모두 받아서 db 입력항목과 그외 것으로 분리
        if(!$args) {
            $args = Context::gets('module_srl','module_category_srl','module_id','layout_srl','skin','browser_title','description','is_default','header_text','footer_text','admin_id');
            $extra_var = delObjectVars(Context::getRequestVars(), $args);
        }

        $args->module = 'planner';
        $args->mid = $args->module_id;
        unset($args->module_id);
        if($args->is_default != 'Y') $args->is_default = 'N';

        // 기본 값외의 것들을 정리
        if($extra_var->use_category!='Y') $extra_var->use_category = 'N';
        unset($extra_var->act);
        unset($extra_var->page);
        unset($extra_var->module_id);
        unset($extra_var->module_srl);

        // $extra_var를 serialize
        $args->extra_vars = serialize($extra_var);

        if($args->is_default == 'Y') $oModuleController->clearDefaultModule();

        // module_srl의 값에 따라 insert/update
        if(!$args->module_srl) {
            $output = $oModuleController->insertModule($args);
            $msg_code = 'success_registed';

            // 파일업로드, 댓글 파일업로드, 관리에 대한 권한 지정
            if($output->toBool()) {
                $oMemberModel = &getModel('member');
                $admin_group = $oMemberModel->getAdminGroup();
                $admin_group_srl = $admin_group->group_srl;

                $module_srl = $output->get('module_srl');
                $grants = serialize(array('manager' => array($admin_group_srl)));

                $oModuleController->updateModuleGrant($module_srl, $grants);
            }
        } else {
            $output = $oModuleController->updateModule($args);
            $msg_code = 'success_updated';
        }

        if(!$output->toBool()) return $output;

        $this->add('page', Context::get('page'));
        $this->add('module_srl', $output->get('module_srl'));
        $this->setMessage($msg_code);
    }
}
?>