<?php
/**
 * @brief  planner 모듈의 model class
 * @author BNU <bnufactory@gmail.com>
 **/

require_once(_XE_PATH_.'modules/planner/JSON.php');

class plannerModel extends planner {

    function init() {
        parent::init();
    }


    function getEntries($entry_srl = null) {
        if($entry_srl) {
            $args->entry_srl = $entry_srl;
            $output = executeQueryArray('planner.getEntry', $args);
        } else {
            $owner_srl = Context::get('owner_srl');
            $begin_date = Context::get('begin_date').'000000';
            $end_date = Context::get('end_date').'235959';



            $this->owner_srl = $owner_srl;
            $this->begin_date = $begin_date;
            $this->end_date = $end_date;

            $args->owner_srl = $this->owner_srl;
            $args->begin_date = $this->begin_date;
            $args->end_date = $this->end_date;
            $output = executeQueryArray('planner.getEntries', $args);
        }
        return $output;
    }


    function getEntriesJSON($entry_srl = null) {
        $output = $this->getEntries($entry_srl);

        // JSON 형식으로 변환
        if($output->data) {
            foreach($output->data as $key => $entry) {
                if(!$entry->end_date) $entry->end_date = $entry->begin_date;
                // 엔트리 JSON 배열 포맷으로
                $entries[$key]->id = $entry->entry_srl;
                $entries[$key]->begin_date = zdate($entry->begin_date, 'Ymd\THis\Z0', false);
                $entries[$key]->end_date = zdate($entry->end_date, 'Ymd\THis\Z0', false);
                $entries[$key]->title = $entry->title;
                $entries[$key]->type = $entry->type;
                $entries[$key]->description = $entry->description;
            }
            $oJSON = new JSON;
            $entries = $oJSON->serialize($entries);
            $this->add('entries', $entries);
        }
        if($entry_srl) { return $entries; }
    }


    function getCategoryXmlFile($module_srl) {
        $xml_file = sprintf('files/cache/planner_category/%s.xml.php', $module_srl);
        if(!file_exists($xml_file)) {
            $oPlannerController = &getController('planner');
            $oPlannerController->makeCategoryFile($module_srl);
        }
        return $xml_file;
    }


    function getCategoryList($obj) {
        $args->module_srl = $obj->module_srl;
        $args->sort_index = $obj->sort_index;
        $output = executeQueryArray('planner.getCategoryList', $args);
        return $output->data;
    }
}
?>