<?php
/**
 * @brief  planner 모듈의 View class
 * @author BNU <bnufactory@gmail.com>
 **/
class plannerView extends planner {

    function init() {
        parent::init();

        // module_srl이 있으면 미리 체크하여 존재하는 모듈이면 module_info 세팅
        $module_srl = Context::get('module_srl');
        if(!$module_srl && $this->module_srl) {
            $module_srl = $this->module_srl;
            Context::set('module_srl', $module_srl);
        }

        // module model 객체 생성
        $oModuleModel = &getModel('module');

        // module_srl이 넘어오면 해당 모듈의 정보를 미리 구해 놓음
        if($module_srl) {
            $module_info = $oModuleModel->getModuleInfoByModuleSrl($module_srl);
            if(!$module_info) {
                Context::set('module_srl','');
                $this->act = 'list';
            } else {
                $this->module_info = $module_info;
                Context::set('module_info', $module_info);
            }
        }

        $skin = $this->module_info->skin;

        // 템플릿 경로 지정
        $template_path = sprintf('%sskins/%s', $this->module_path, $skin);
        $this->setTemplatePath($template_path);
    }



    function dispPlannerContent() {
        Context::set('parent_srl', $this->module_info->module_srl);
    	$this->setTemplateFile('index');
    }

    function dispPlannerMyPlanner() {
        // 개인화 활성 확인
        if(!$this->module_config) return $this->dispPlannerMessage('msg_disable_personalize');

        // 로그인 확인
        $logged_info = Context::get('logged_info');
        if(!$logged_info) return $this->dispPlannerMessage('msg_not_logged');

        // 템플릿 경로 지정
        $personalize_skin = $this->module_config->personalize_skin;
        $template_path = sprintf('%sskins/%s', $this->module_path, $personalize_skin);
        $this->setTemplatePath($template_path);


        $oPlannerModel = &getModel('planner');

        // 쿼리 변수 세팅
        $args->parent_srl = $logged_info->member_srl;
        $args->type = 'todo';
        $output_todo = $oPlannerModel->getTodoList($args);

        Context::set('module_info', $module_info);
        Context::set('todo_list', $output_todo->data);
        Context::set('parent_srl', $logged_info->member_srl);

        $this->setTemplateFile('index');
    }


    function dispPlannerPersConfig() {
        // 템플릿 경로 지정
        $template_path = sprintf('%stpl/', $this->module_path);
        $this->setTemplatePath($template_path);
        $this->setTemplateFile('personalize_config');
    }


    /**
     * @brief 메세지 출력
     **/
    function dispPlannerMessage($msg_code) {
        // 템플릿 경로 지정
        $personalize_skin = $this->module_config->personalize_skin;
        if(!$personalize_skin) $personalize_skin = 'personalize';
        $template_path = sprintf('%sskins/%s', $this->module_path, $personalize_skin);
        $this->setTemplatePath($template_path);

        $msg = Context::getLang($msg_code);
        if(!$msg) $msg = $msg_code;
        Context::set('message', $msg);
        $this->setTemplateFile('message');
    }

}
?>